#include <lcrzo.h>
#include "shared_misc.h"
#if defined _POSIX_SOURCE
 #undef _POSIX_SOURCE
#endif
#define _POSIX_SOURCE 1
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <errno.h>

/*-------------------------------------------------------------*/
int shared_misc_dangerousexample(void)
{ lcrzo_uint8 c;
  int language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  if ( language==LCRZO_GLOBAL_FRLANG )
  { puts("Ceci va perturber le fonctionnement de tout le reseau.");
    lcrzo_epr(lcrzo_stdin_char("Voulez-vous reellement continuer ?",
			       (const lcrzo_uint8*)"oOnN", 'n', &c));
  }
  else
  { puts("This example will disturb your network.");
    lcrzo_epr(lcrzo_stdin_char("Do you really want to continue ?",
			       (const lcrzo_uint8*)"yYnN", 'n', &c));
  }
  if (c=='n' || c=='N') exit(LCRZO_ERR_OK);
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse(lcrzo_sock *psock, 
			       lcrzo_uint16 error1, 
			       lcrzo_uint16 error2, 
			       lcrzo_uint16 error3, 
			       lcrzo_uint16 error4);
int shared_misc_verifyresponse(lcrzo_sock *psock, 
			       lcrzo_uint16 error1, 
			       lcrzo_uint16 error2, 
			       lcrzo_uint16 error3, 
			       lcrzo_uint16 error4)
{ lcrzo_data data, response;
  lcrzo_string errorlist;
  lcrzo_int32 datasize, responsesize;
  lcrzo_int32 index, start, end;
  lcrzo_uint16 goterror;
  lcrzo_uint8 newline[3];
  lcrzo_bool notenough;
  int language, ret;

  /* read response from the socket */
  notenough=LCRZO_TRUE;
  newline[0]=0x0D;
  newline[1]=0x0A;
  newline[2]='\0';
  goterror=0; /*just for the compiler*/
  lcrzo_epr(lcrzo_data_initm_data(NULL, 0, &response, &responsesize));
  while (notenough)
  { /* read */
    lcrzo_epr(lcrzo_sock_readm(psock, LCRZO_TRUE, &data, &datasize));
    lcrzo_epr(lcrzo_data_appendm_data(data, datasize, responsesize, 
				      &response, &responsesize));
    lcrzo_data_free(data);
    /* check for completeness */
    index=0;
    /* the first call should have a null size */
    lcrzo_epr(lcrzo_data_token_data(response, responsesize, 
				    LCRZO_FALSE, -1, +1,
				    newline, 2,
				    &index, NULL, NULL, NULL, NULL));
    /* the second is for us */
    ret=lcrzo_data_token_data(response, responsesize, 
			      LCRZO_FALSE, -1, +1,
			      newline, 2,
			      &index, &start, NULL, &end, NULL);
    if (ret==LCRZO_ERR_OK)
    { /* data will contain the last line */
      lcrzo_epr(lcrzo_data_initm_range(response, responsesize, start, end,
				       &data, &datasize));
      /*lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP);*/

      /* data should contain "xxx " */
      if ( datasize>=4 )
      { if ( isdigit(data[0]) && isdigit(data[1]) && isdigit(data[2]) )
	{ if ( data[3]==' ' ) 
	  { /* ok */
	    notenough=LCRZO_FALSE;
	    data[3]='\0';
	    goterror=atoi(data);
	  }
	}
      }
      lcrzo_data_free(data);
    }
  }
  /* response is not freed */


  /* verify error */
  if ( goterror!=error1 && goterror!=error2 &&
       goterror!=error3 && goterror!=error4 )
  { /* prepare error string */
    lcrzo_epr(lcrzo_string_initm_int(error1, "%d", &errorlist));
    if ( error2 != error1 )
    { lcrzo_epr(lcrzo_string_appendm_char('-', 1, &errorlist));
      lcrzo_epr(lcrzo_string_appendm_int(error2, "%d", &errorlist));
      if ( error3 != error2 )
      { lcrzo_epr(lcrzo_string_appendm_char('-', 1, &errorlist));
	lcrzo_epr(lcrzo_string_appendm_int(error3, "%d", &errorlist));
	if ( error4 != error3 )
	{ lcrzo_epr(lcrzo_string_appendm_char('-', 1, &errorlist));
	  lcrzo_epr(lcrzo_string_appendm_int(error4, "%d", &errorlist));
	}
      }
    }
    /* print message */
    lcrzo_epr(lcrzo_global_get_language(&language));
    if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Je voulais %s, mais j'ai recu %d\n", errorlist, goterror); 
    else
      printf("I wanted %s, but I received %d\n", errorlist, goterror); 
    lcrzo_epr(lcrzo_data_print(response, responsesize , LCRZO_PRINTTYPE_DUMP));
    lcrzo_string_free(errorlist);
    lcrzo_data_free(response);
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }

  lcrzo_data_free(response);
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse1(lcrzo_sock *psock, 
				lcrzo_uint16 error)
{ return(shared_misc_verifyresponse(psock, error, error, error, error));
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse2(lcrzo_sock *psock, 
				lcrzo_uint16 error1, 
				lcrzo_uint16 error2)
{ return(shared_misc_verifyresponse(psock, error1, error2, error2, error2));
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse3(lcrzo_sock *psock, 
				lcrzo_uint16 error1, 
				lcrzo_uint16 error2, 
				lcrzo_uint16 error3)
{ return(shared_misc_verifyresponse(psock, error1, error2, error3, error3));
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse4(lcrzo_sock *psock, 
				lcrzo_uint16 error1, 
				lcrzo_uint16 error2, 
				lcrzo_uint16 error3, 
				lcrzo_uint16 error4)
{ return(shared_misc_verifyresponse(psock, error1, error2, error3, error4));
}


/*-------------------------------------------------------------*/
int shared_misc_printnumberbase(char *string, int base)
{ lcrzo_uint32 i;
  char *p;
  int language;

  lcrzo_epr(lcrzo_global_get_language(&language));
  errno=0;
  i=strtoul(string, &p, base);
  if (*p!='\0')
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Le nombre %s n'est pas en base %d\n", string, base);
    else
      printf("The number %s is not in base %d\n", string, base);
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }
  if ( errno==ERANGE ) 
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Le nombre %s en base %d est trop long\n", string, base);
    else
      printf("The number %s in base %d is too long\n", string, base);
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_epr(shared_misc_printnumber(i));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_printnumber(lcrzo_uint32 number)
{ lcrzo_uint32 i, n, print;
  lcrzo_ipa ipa;
  int language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  /* binary */
  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("Binaire        : ");
  else
    printf("Binary         : ");
  print=0;
  for ( i=31 ; i>0 ; i-- )
  { n=(number>>i)&1;
    if (print)
    { if ( !((i+1)%4) ) printf(" ");
      printf("%c", (n==0)?'0':'1');
    }
    else
    { if (n==1)
      { print=1;
        printf("1");
      }
    }
  }
  printf("%c\n", (number&1)?'1':'0');

  /* octal */
  printf("Octal          : %lo\n", number);

  /* decimal */
  printf("Decimal        : %lu\n", number);
  if (number<=0xFFFF)
    printf("Decimal 16n    : %u\n", lcrzo_htons(number));
  printf("Decimal 32n    : %lu\n", lcrzo_htonl(number));

  /* hexadecimal */
  printf("Hexa           : %lX\n", number);
  if (number<=0xFFFF)
    printf("Hexa 16n       : %X\n", lcrzo_htons(number));
  printf("Hexa 32n       : %lX\n", lcrzo_htonl(number));

  /* character */
  if ( number<=255 )
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Caractere      : ");
    else
      printf("Character      : ");
    printf("%c\n", (char)number);
  }
  if ( number<=0xFFFF && lcrzo_htons(number)<=255 )
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Caractere 16n  : ");
    else
      printf("Character 16n  : ");
    printf("%c\n", (char)lcrzo_htons(number));
  }
  if ( lcrzo_htonl(number)<=255 )
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Caractere 32n  : ");
    else
      printf("Character 32n  : ");
    printf("%c\n", (char)lcrzo_htonl(number));
  }

  /* IP address */
  lcrzo_epr(lcrzo_ipa_init_ipl(number, ipa));
  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("Adresse IP     : ");
  else
    printf("IP address     : ");
  printf("%d.%d.%d.%d\n", 
	 (unsigned int)ipa[0], (unsigned int)ipa[1],
	 (unsigned int)ipa[2], (unsigned int)ipa[3]);
  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("Adresse IP 32n : ");
  else
    printf("IP address 32n : ");
  printf("%d.%d.%d.%d\n",
	 (unsigned int)ipa[3], (unsigned int)ipa[2],
	 (unsigned int)ipa[1], (unsigned int)ipa[0]);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_printdata(lcrzo_data data, lcrzo_int32 datasize)
{ int language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("***********Texte affichable :\n");
  else
    printf("***********Printable text :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_PTEXTN));

  printf("***********Dump :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP));

  printf("***********Hexadecimal :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_HEXAN));

  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("***********Mixte :\n");
  else
    printf("***********Mixed :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_MIXEDN));

  printf("***********Base 64 :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_BASE64N));
  return (LCRZO_ERR_OK);
}


